/* SREhttp/2 procedure returns converted contents from one codepage to another 
   28 Dec 2002: This has NOT been fully tested. */

/* 
   This procedure converts output of SREhttp/2 from one Cyrillic codepage
   to another using information about user browser and some default
   settings

   For TEXT/PLAIN documents there is no guessing of document's codepage
   and BASE_SET codepage is used.
  
   For TEXT/HTML documents the <META HTTP-EQUIV> keyword is looked for and
   if found the information from CHARSET field is used and this tag is deleted.
   In other cases the BASE_SET codepage is used.

   Before using this procedure check the rules for determining codepage
   for browsers - maybe you'll find that some are unapplicable!!!

*/

sreh2_cvtpage:
/* parse arg contents,fileflag,mimetype,clen */
parse arg contents,fileflag,mimetype,astring,req_string,seluse2


/* Parameter ADD_EXTERNAL_DEFS determinies where to load additional
   information about browsers and corresponding preferred codepages.
   It must be fully qualified file name or 0 if you do not want to
   load additional information.

   For example, ADD_EXTERNAL_DEFS='D:\SRE2003\SREHTTP2\CFG\CP_BROWS.DAT' means
   to load information from file D:\SRE2003\SREHTTP2\CFG\CP_BROWS.DAT

   WARNING!!! Definition from database overrides default (hardcoded) values

*/

/**** Begin user configurable parameters ****/
add_external_defs=0

base_cp = 878       /* default codepage for documents */



agent_cp = 878        /* default codepage for unknown browsers 
                         You can change this to 0 (zero) - it will
                         not perform any translation */


/**** End  user configurable parameters ****/



/* Loading functions to translate codepages */

if rxfuncquery('RxCpTranslate')=1 then do
   goti1=RxFuncAdd('RxCpTranslate','RXCPAGE','RxCpTranslate')
   if goti1=1 then do
        ss=sre_write_error(" SREH2INI: Error in CVT_PAGE pre-response procedure: unable to load RxCpTranslate function ",,1)
        return ''
   end
end


/* Creating META descriptions for each Cyrillic codepages */
/* You can add some or delete unusable - do not forget to */
/* change TOTAL_METAS after changes                       */

total_metas = 13

meta_des.1 = '<META HTTP-EQUIV="CONTENT-TYPE" CONTENT="TEXT/HTML; CHARSET=KOI8-R">'
meta_des.2 = '<META HTTP-EQUIV="CONTENT-TYPE" CONTENT="TEXT/HTML; CHARSET=KOI8">'
meta_des.3 = '<META HTTP-EQUIV="CONTENT-TYPE" CONTENT="TEXT/HTML; CHARSET=KOI8R">'
meta_des.4 = '<META HTTP-EQUIV="CONTENT-TYPE" CONTENT="TEXT/HTML; CHARSET=KOI-8R">'
meta_des.5 = '<META HTTP-EQUIV="CONTENT-TYPE" CONTENT="TEXT/HTML; CHARSET=KOI-8">'
meta_des.6 = '<META HTTP-EQUIV="CONTENT-TYPE" CONTENT="TEXT/HTML; CHARSET=WIN-1251">'
meta_des.7 = '<META HTTP-EQUIV="CONTENT-TYPE" CONTENT="TEXT/HTML; CHARSET=WIN1251">'
meta_des.8 = '<META HTTP-EQUIV="CONTENT-TYPE" CONTENT="TEXT/HTML; CHARSET=WINDOWS1251">'
meta_des.9 = '<META HTTP-EQUIV="CONTENT-TYPE" CONTENT="TEXT/HTML; CHARSET=WINDOWS-1251">'
meta_des.10 = '<META HTTP-EQUIV="CONTENT-TYPE" CONTENT="TEXT/HTML; CHARSET=CP866">'
meta_des.11 = '<META HTTP-EQUIV="CONTENT-TYPE" CONTENT="TEXT/HTML; CHARSET=CP-866">'
meta_des.12 = '<META HTTP-EQUIV="CONTENT-TYPE" CONTENT="TEXT/HTML; CHARSET=IBM866">'
meta_des.13 = '<META HTTP-EQUIV="CONTENT-TYPE" CONTENT="TEXT/HTML; CHARSET=IBM-866">'

meta_set.1 = 878
meta_set.2 = 878
meta_set.3 = 878
meta_set.4 = 878
meta_set.5 = 878
meta_set.6 = 1251
meta_set.7 = 1251
meta_set.8 = 1251
meta_set.9 = 1251
meta_set.10 = 866
meta_set.11 = 866
meta_set.12 = 866
meta_set.13 = 866

/* Determine base codepage (the codepage the original text files and
   all files in which there is no META charset are stored)
*/

/* Rules to determine codepage for different browsers 
   Add your rules or change presented when nesessary
*/

theagent=sre_reqfield('user-agent')

total_browsers = 19   /* total number of known browsers - change this
                         if you add or delete some 
                         WARNING!!! The 0 (zero) value for br_cp.i
                         means "Do not perform translation"      */

br_str.1  = "Mozilla/4.0 (compatible; MSIE 4.01; Windows 98)"
br_str.2  = "Mozilla/4.0 (compatible; MSIE 4.0; Windows 95)"
br_str.3  = "Mozilla/4.0 (compatible; MSIE 4.01; Windows NT)"
br_str.4  = "Lynx/2.8rel.2 libwww-FM/2.14"
br_str.5  = "Mozilla/4.5 [en] (X11; I; SunOS 5.6 i86pc)"
br_str.6  = "Mozilla/2.0 (compatible; MSIE 3.01; Windows 95)"
br_str.7  = "Mozilla/4.04 [en] (Win95; I)"
br_str.8  = "Mozilla/4.5 [en] (Win95; I)"
br_str.9  = "Mozilla/4.07 [en] (X11; I; Linux 2.0.36 i686)"
br_str.10 = "Mozilla/4.0 (compatible; MSIE 5.0b1; Windows 95)"
br_str.11 = "Net Vampire/3.0"
br_str.12 = "Mozilla/2.02 (OS/2; I)"
br_str.13 = "Mozilla/2.02 (X11; I)"
br_str.14 = "Mozilla/3.0 (OS/2; I)"
br_str.15 = "Mozilla/3.0 (X11; I)"
br_str.16 = "Mozilla/4.04 [ru] (OS/2; I)"
br_str.17 = "Mozilla/4.04 [en] (OS/2; I)"
br_str.18 = "IBM-WebExplorer-DLL/v1.2"
br_str.19 = "Yandex/1.01.001 (compatible; Win16; I)"

br_cp.1  = 1251
br_cp.2  = 1251
br_cp.3  = 1251
br_cp.4  = 878
br_cp.5  = 878
br_cp.6  = 1251
br_cp.7  = 1251
br_cp.8  = 1251
br_cp.9  = 878
br_cp.10 = 1251
br_cp.11 = 1251
br_cp.12 = 878
br_cp.13 = 878
br_cp.14 = 878
br_cp.15 = 878
br_cp.16 = 878
br_cp.17 = 878
br_cp.18 = 866
br_cp.19 = 0

do i=1 to total_browsers
  if (pos(br_str.i, theagent) <> 0) then do
    agent_cp = br_cp.i
    leave
  end
end

/* Adding information from external database defined in the 
   ADD_EXTERNAL_DEFS parameter
*/

add_browsers = 0
i = 0
if (add_external_defs \= 0) then 
  if (stream(add_external_defs, 'c', 'query exists') <> '') then do
    rc = stream(add_external_defs, 'c', 'open read')
    do while lines(add_external_defs)
      l = linein(add_external_defs)
      if ((pos('|', l) <> 0) & (left(l,1) <> '#')) then do
        i = i + 1
        parse var l br_str2.i '|' br_cp2.i
        br_str2.i = strip(br_str2.i)
        br_cp2.i  = strip(br_cp2.i)
      end
    end
    add_browsers = i
    rc = stream(add_external_defs, 'c', 'close')
  end

if (add_browsers <> 0) then do
  do i=1 to add_browsers
    if (pos(br_str2.i, theagent) <> 0) then do
      agent_cp = br_cp2.i
      leave
    end
  end
end

if fileflag=1 then 
   jlen=stream(contents,'c','query size')
else
   jlen=length(contents)

select
  when translate(mimetype)='TEXT/PLAIN' then do
     if fileflag=1 then do
       foo=stream(contents,'c','open read')
       aa=charin(contents,1,jlen)
       foo=stream(contents,'c','close')
     end
     else do
      aa=contents
     end
     if (agent_cp = 0) then agent_cp = base_cp
call pmprintf(" foo2 ")
    arf=RxCpTranslate(aa, base_cp, agent_cp)
call pmprintf(" foo2a")
     return '1 '||'0d0a'x||arf
   end

  when translate(mimetype)='TEXT/HTML' then do

     if fileflag=1 then do
       foo=stream(contents,'c','open read')
       aa=charin(contents,1,jlen)
       foo=stream(contents,'c','close')
     end 
     else do
      aa=contents
     end

     /* Determining META keyword and if it exists determining base
        codepage and deleting this tag from content at all
     */
     naa = upper(aa)
     do i=1 to total_metas
       j = pos(meta_des.i , naa)
       if (j <> 0) then do
         base_cp = meta_set.i
         aa = delstr(aa, j, length(meta_des.i))
         leave
       end
     end
     newlen=length(aa)
     if (agent_cp = 0) then agent_cp = base_cp
call sre_pmprintf(" foo1 "base_cp','agent_cp'=='||aa)
     arf=RxCpTranslate(aa, base_cp, agent_cp)
call pmprintf(" foo1a ")
     return '1 '||'0d0a'x||arf

   end
  otherwise do
     return ''    /* let SREhttp/2  handle it */
  end 
end

